--- old/exception_lists/packaging	2012-08-18 10:36:54.804005109 +0000
+++ new/exception_lists/packaging	2012-08-18 10:36:54.862680913 +0000
@@ -145,6 +145,7 @@
 usr/lib/amd64/llib-lipsecutil.ln	i386
 usr/lib/sparcv9/llib-lipsecutil.ln	sparc
 #
+usr/include/inet/dccp_impl.h
 usr/include/inet/ip_impl.h
 usr/include/inet/ip_ndp.h
 usr/include/inet/ip2mac_impl.h
--- old/usr/src/cmd/cmd-inet/etc/sock2path.d/system%2Fkernel	2012-08-18 10:36:55.403356041 +0000
+++ new/usr/src/cmd/cmd-inet/etc/sock2path.d/system%2Fkernel	2012-08-18 10:36:55.454975507 +0000
@@ -52,3 +52,5 @@
 	29	4	1	/dev/spdsock
 
 	31	1	0	trill
+
+	2	6	33	dccp
--- old/usr/src/cmd/cmd-inet/usr.bin/netstat/netstat.c	2012-08-18 10:36:55.854250712 +0000
+++ new/usr/src/cmd/cmd-inet/usr.bin/netstat/netstat.c	2012-08-18 10:36:55.900569885 +0000
@@ -193,6 +193,8 @@
 static void		udp_report(const mib_item_t *item);
 static void		group_report(mib_item_t *item);
 static void		dce_report(mib_item_t *item);
+static void		sctp_report(const mib_item_t *item);
+static void		dccp_report(const mib_item_t *item);
 static void		print_ip_stats(mib2_ip_t *ip);
 static void		print_icmp_stats(mib2_icmp_t *icmp);
 static void		print_ip6_stats(mib2_ipv6IfStatsEntry_t *ip6);
@@ -203,7 +205,7 @@
 static void		print_rawip_stats(mib2_rawip_t *rawip);
 static void		print_igmp_stats(struct igmpstat *igps);
 static void		print_mrt_stats(struct mrtstat *mrts);
-static void		sctp_report(const mib_item_t *item);
+static void		print_dccp_stats(mib2_dccp_t *dccp);
 static void		sum_ip6_stats(mib2_ipv6IfStatsEntry_t *ip6,
 			    mib2_ipv6IfStatsEntry_t *sum6);
 static void		sum_icmp6_stats(mib2_ipv6IfIcmpEntry_t *icmp6,
@@ -284,6 +286,8 @@
 static int sctpEntrySize;
 static int sctpLocalEntrySize;
 static int sctpRemoteEntrySize;
+static int dccpEntrySize;
+static int dccp6EntrySize;
 
 #define	protocol_selected(p)	(proto == IPPROTO_MAX || proto == (p))
 
@@ -477,6 +481,8 @@
 			} else if (strcmp(optarg, "raw") == 0 ||
 			    strcmp(optarg, "rawip") == 0) {
 				proto = IPPROTO_RAW;
+			} else if (strcmp(optarg, "dccp") == 0) {
+				proto = IPPROTO_DCCP;
 			} else {
 				fatal(1, "%s: unknown protocol.\n", optarg);
 			}
@@ -622,6 +628,8 @@
 					tcp_report(item);
 				if (protocol_selected(IPPROTO_SCTP))
 					sctp_report(item);
+				if (protocol_selected(IPPROTO_DCCP))
+					dccp_report(item);
 			}
 			if (Iflag)
 				if_report(item, ifname, Iflag_only, once_only);
@@ -1006,6 +1014,7 @@
 			case MIB2_UDP:
 			case MIB2_SCTP:
 			case EXPER_RAWIP:
+			case MIB2_DCCP:
 				nitems++;
 			}
 	}
@@ -1452,6 +1461,10 @@
 				prevp = diffptr++;
 				break;
 			}
+			case MIB2_DCCP: {
+				/* XXX:DCCP */
+				break;
+			}
 			case EXPER_RAWIP: {
 				mib2_rawip_t *r2;
 				mib2_rawip_t *r1;
@@ -1861,6 +1874,17 @@
 			sctpRemoteEntrySize = sctp->sctpRemoteEntrySize;
 			break;
 		}
+		case MIB2_DCCP: {
+			mib2_dccp_t	*dccp = (mib2_dccp_t *)item->valp;
+
+			dccpEntrySize = dccp->dccpConnTableSize;
+			dccp6EntrySize = dccp->dccp6ConnTableSize;
+			assert(IS_P2ALIGNED(dccpEntrySize,
+			    sizeof (mib2_dccpConnEntry_t *)));
+			assert(IS_P2ALIGNED(dccp6EntrySize,
+			    sizeof (mib2_dccp6ConnEntry_t *)));
+			break;
+		}
 		}
 	} /* 'for' loop 1 ends */
 
@@ -1896,6 +1920,8 @@
 		(void) printf("\tsctpLocalEntrySize %d\n", sctpLocalEntrySize);
 		(void) printf("\tsctpRemoteEntrySize %d\n",
 		    sctpRemoteEntrySize);
+		(void) printf("\tdccpEntrySize %d\n", dccpEntrySize);
+		(void) printf("\ttcp6EntrySize %d\n", dccp6EntrySize);
 	}
 }
 
@@ -5431,6 +5457,133 @@
 		free(attrs);
 }
 
+/* ------------------------------ DCCP_REPORT------------------------------- */
+
+static const char dccp_hdr_v4[] =
+"\nDCCP: IPv4\n";
+static const char dccp_hdr_v4_compat[] =
+"\nDCCP\n";
+static const char dccp_hdr_v4_verbose[] =
+"Local/Remote Address Swind  Snext     Suna   Rwind  Rnext     Rack   "
+" Rto   Mss     State\n"
+"-------------------- ----- -------- -------- ----- -------- -------- "
+"----- ----- -----------\n";
+static const char dccp_hdr_v4_normal[] =
+"   Local Address        Remote Address    Swind Send-Q Rwind Recv-Q "
+"   State\n"
+"-------------------- -------------------- ----- ------ ----- ------ "
+"-----------\n";
+
+static const char dccp_hdr_v6[] =
+"\nDCCP: IPv6\n";
+static const char dccp_hdr_v6_verbose[] =
+"Local/Remote Address              Swind  Snext     Suna   Rwind  Rnext   "
+"  Rack    Rto   Mss    State      If\n"
+"--------------------------------- ----- -------- -------- ----- -------- "
+"-------- ----- ----- ----------- -----\n";
+static const char dccp_hdr_v6_normal[] =
+"   Local Address                     Remote Address                 "
+"Swind Send-Q Rwind Recv-Q   State      If\n"
+"--------------------------------- --------------------------------- "
+"----- ------ ----- ------ ----------- -----\n";
+
+static boolean_t dccp_report_item_v4(const mib2_dccpConnEntry_t *,
+    boolean_t, const mib2_transportMLPEntry_t *);
+static boolean_t dccp_report_item_v6(const mib2_dccp6ConnEntry_t *,
+    boolean_t, const mib2_transportMLPEntry_t *);
+
+static void
+dccp_report(const mib_item_t *item)
+{
+	mib2_dccpConnEntry_t		*dp;
+	mib2_transportMLPEntry_t	**v4_attrs;
+	mib2_transportMLPEntry_t	**v6_attrs;
+	mib2_transportMLPEntry_t	**v4a;
+	mib2_transportMLPEntry_t	**v6a;
+	mib2_transportMLPEntry_t	*aptr;
+	boolean_t			print_hdr_once_v4 = B_TRUE;
+	boolean_t			print_hdr_once_v6 = B_TRUE;
+	int				jtemp = 0;
+
+	if (!protocol_selected(IPPROTO_DCCP)) {
+		return;
+	}
+
+	v4_attrs = family_selected(AF_INET) && RSECflag ?
+	    gather_attrs(item, MIB2_DCCP, MIB2_DCCP_CONN, dccpEntrySize) :
+	    NULL;
+	v6_attrs = family_selected(AF_INET6) && RSECflag ?
+	    gather_attrs(item, MIB2_DCCP6, MIB2_DCCP6_CONN, dccp6EntrySize) :
+	    NULL;
+
+	v4a = v4_attrs;
+	v6a = v6_attrs;
+	for (; item != NULL; item = item->next_item) {
+		if (Xflag) {
+			(void) printf("\n--- Entry %d ---\n", ++jtemp);
+			(void) printf("Group = %d, mib_id = %d, "
+			    "length = %d, valp = 0x%p\n",
+			    item->group, item->mib_id,
+			    item->length, item->valp);
+		}
+
+		if (item->group == MIB2_DCCP) {
+			for (dp = (mib2_dccpConnEntry_t *)item->valp;
+			    (char *)dp < (char *)item->valp + item->length;
+			    dp = (mib2_dccpConnEntry_t *)((char *)dp +
+			    dccpEntrySize)) {
+				aptr = v4a == NULL ? NULL : *v4a++;
+				print_hdr_once_v4 = dccp_report_item_v4(dp,
+				    print_hdr_once_v4, aptr);
+			}
+		}
+	}
+
+	(void) fflush(stdout);
+
+	if (v4_attrs != NULL) {
+		free(v4_attrs);
+	}
+	if (v6_attrs != NULL) {
+		free(v6_attrs);
+	}
+}
+
+static boolean_t
+dccp_report_item_v4(const mib2_dccpConnEntry_t *dp, boolean_t first,
+    const mib2_transportMLPEntry_t *attr)
+{
+	char	lname[MAXHOSTNAMELEN + MAXHOSTNAMELEN + 1];
+	char	fname[MAXHOSTNAMELEN + MAXHOSTNAMELEN + 1];
+
+	if (first) {
+		(void) printf(v4compat ? dccp_hdr_v4_compat : dccp_hdr_v4);
+		(void) printf(Vflag ? dccp_hdr_v4_verbose : dccp_hdr_v4_normal);
+	}
+
+	(void) printf("%-20s %-20s %5u %6d %5u %6d %s\n",
+	    pr_ap(dp->dccpConnLocalAddress,
+	    dp->dccpConnLocalPort, "dccp", lname, sizeof (lname)),
+	    pr_ap(dp->dccpConnRemAddress,
+	    dp->dccpConnRemPort, "dccp", fname, sizeof (fname)),
+	    0,
+	    0,
+	    0,
+	    0,
+	    0);
+
+	print_transport_label(attr);
+
+	return (B_FALSE);
+}
+
+static boolean_t
+dccp_report_item_v6(const mib2_dccp6ConnEntry_t *dp, boolean_t first,
+    const mib2_transportMLPEntry_t *attr)
+{
+	return (B_FALSE);
+}
+
 static char *
 plural(int n)
 {
--- old/usr/src/cmd/cmd-inet/usr.sbin/ipadm/ipadm.c	2012-08-18 10:36:56.557953842 +0000
+++ new/usr/src/cmd/cmd-inet/usr.sbin/ipadm/ipadm.c	2012-08-18 10:36:56.590295328 +0000
@@ -633,7 +633,7 @@
 
 /*
  * Properties to be displayed is in `statep->sps_proplist'. If it is NULL,
- * for all the properties for the specified object, relavant information, will
+ * for all the properties for the specified object, relevant information, will
  * be displayed. Otherwise, for the selected property set, display relevant
  * information
  */
@@ -855,7 +855,7 @@
 
 /*
  * Display information for all or specific protocol properties, either for a
- * given protocol or for supported protocols (IP/IPv4/IPv6/TCP/UDP/SCTP)
+ * given protocol or for supported protocols (IP/IPv4/IPv6/TCP/UDP/SCTP/DCCP)
  */
 static void
 do_show_prop(int argc, char **argv, const char *use)
--- old/usr/src/cmd/cmd-inet/usr.sbin/snoop/Makefile	2012-08-18 10:36:57.051774250 +0000
+++ new/usr/src/cmd/cmd-inet/usr.sbin/snoop/Makefile	2012-08-18 10:36:57.124376039 +0000
@@ -28,8 +28,8 @@
 OBJS=	nfs4_xdr.o snoop.o snoop_aarp.o snoop_adsp.o snoop_aecho.o \
 	snoop_apple.o snoop_arp.o snoop_atp.o snoop_bparam.o \
 	snoop_bpdu.o \
-	snoop_capture.o snoop_dhcp.o snoop_dhcpv6.o snoop_display.o \
-	snoop_dns.o snoop_ether.o \
+	snoop_capture.o snoop_dccp.o snoop_dhcp.o snoop_dhcpv6.o \
+	snoop_display.o snoop_dns.o snoop_ether.o \
 	snoop_filter.o snoop_http.o snoop_icmp.o snoop_igmp.o snoop_ip.o \
 	snoop_ipaddr.o snoop_ipsec.o snoop_isis.o \
 	snoop_ldap.o snoop_mip.o snoop_mount.o \
--- old/usr/src/cmd/cmd-inet/usr.sbin/snoop/snoop.h	2012-08-18 10:36:57.543773573 +0000
+++ new/usr/src/cmd/cmd-inet/usr.sbin/snoop/snoop.h	2012-08-18 10:36:57.558162787 +0000
@@ -238,6 +238,8 @@
 extern int interpret_ah(int, uint8_t *, int, int);
 struct sctp_hdr;
 extern void interpret_sctp(int, struct sctp_hdr *, int, int);
+struct dccphdr;
+extern int interpret_dccp(int, struct dccphdr *, int, int);
 extern void interpret_mip_cntrlmsg(int, uchar_t *, int);
 struct dhcp;
 extern int interpret_dhcp(int, struct dhcp *, int);
--- /dev/null	2012-08-18 10:36:57.000000000 +0000
+++ new/usr/src/cmd/cmd-inet/usr.sbin/snoop/snoop_dccp.c	2012-08-18 10:36:57.854154024 +0000
@@ -0,0 +1,433 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License, Version 1.0 only
+ * (the "License").  You may not use this file except in compliance
+ * with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+/*
+ * Copyright 2005 Sun Microsystems, Inc.  All rights reserved.
+ * Copyright 2012 David Hoeppner.  All rights reserved.
+ */
+
+#include <stdio.h>
+#include <ctype.h>
+#include <string.h>
+#include <fcntl.h>
+#include <string.h>
+#include <sys/types.h>
+#include <sys/time.h>
+
+#include <sys/socket.h>
+#include <sys/sockio.h>
+#include <net/if.h>
+#include <netinet/in_systm.h>
+#include <netinet/in.h>
+#include <netinet/ip.h>
+#include <netinet/if_ether.h>
+#include <netinet/dccp.h>
+#include "snoop.h"
+
+/*
+ * Snoop interpreter for DCCP (RFC4340)
+ *
+ */
+
+extern char *dlc_header;
+
+static char	*get_type(uint8_t);
+static void	print_dccpoptions_summary(uchar_t *, uchar_t *);
+static void	print_dccpoptions(uchar_t *, uchar_t *);
+
+static char *
+get_type(uint8_t type)
+{
+	switch (type) {
+	case 0:
+		return ("DCCP-Request");
+	case 1:
+		return ("DCCP-Response");
+	case 2:
+		return ("DCCP-Data");
+	case 3:
+		return ("DCCP-Ack");
+	case 4:
+		return ("DCCP-DataAck");
+	case 5:
+		return ("DCCP-CloseReq");
+	case 6:
+		return ("DCCP-Close");
+	case 7:
+		return ("DCCP-Reset");
+	case 8:
+		return ("DCCP-Sync");
+	case 9:
+		return ("DCCP-SyncAck");
+	case 10 ... 15:
+		return ("Reserved");
+
+	default:
+		return ("Unknown");
+	}
+}
+
+int
+interpret_dccp(int flags, struct dccphdr *dccp, int iplen, int fraglen)
+{
+	char		*data;
+	char		*line;
+	char		*endline;
+	uint64_t	seq;
+	uint64_t	ack;
+	int		hdrlen;
+	int		dccplen;
+	int		option_offset;
+	int		i;
+
+	hdrlen = dccp->dh_offset * 4;
+	data = (char *)dccp + hdrlen;
+	dccplen = iplen - hdrlen;
+	fraglen -= hdrlen;
+
+	if (fraglen < 0) {
+		return (fraglen + hdrlen);	/* Incomplete header */
+	}
+
+	if (fraglen > dccplen) {
+		fraglen = dccplen;
+	}
+
+	if (dccp->dh_x == 1) {
+		switch (dccp->dh_type) {
+		case 0:		/* DCCP-Request */
+			option_offset = 20;
+			break;
+		case 1:		/* DCCP-Response */
+			option_offset = 28;
+			break;
+		case 7:		/* DCCP-Reset */
+			option_offset = 28;
+			break;
+		case 8:		/* DCCP-Sync */
+		case 9:		/* DCCP-SyncAck */
+			option_offset = 24;
+			break;
+
+		default:
+			option_offset = 20;
+			break;
+		}
+
+		/* Sequence number */
+		seq = ntohs(dccp->dh_seq);
+		seq <<= 32;
+		seq += (uint32_t)dccp + sizeof (struct dccphdr);
+
+		ack = (uint32_t)(dccp + 16) & 0xffff;
+	} else {
+		switch (dccp->dh_type) {
+		case 0:		/* DCCP-Request */
+		case 1:		/* DCCP-Response */
+		case 7:		/* DCCP-Reset */
+		case 8:		/* DCCP-Sync */
+		case 9:		/* DCCP-SyncAck */
+			break;
+
+		default:
+			option_offset = 20;
+			break;
+		}
+
+		/* Sequence number */
+		seq = dccp->dh_res_seq << 16;
+		seq |= ntohs(dccp->dh_seq);
+	}
+
+	if (flags & F_SUM) {
+		line = get_sum_line();
+		endline = line + MAXLINE;
+
+		(void) snprintf(line, endline - line, "DCCP D=%d S=%d",
+		    ntohs(dccp->dh_dport), ntohs(dccp->dh_sport));
+		line += strlen(line);
+
+		(void) snprintf(line, endline - line, "CCval=%d CsCov=%d",
+		    dccp->dh_ccval, dccp->dh_cscov);
+
+		(void) snprintf(line, endline - line, " Seq=%u Len=%d",
+		    seq, dccplen);
+		line += strlen(line);
+
+		/*
+		 * All packets except DCCP-Request and DCCP-Data carry
+		 * an acknowledgement number.
+		 */
+		if (dccp->dh_type != 0 && dccp->dh_type != 2) {
+			(void) snprintf(line, endline - line, " Ack=%u",
+			    seq, dccplen);
+		}
+		line += strlen(line);
+
+		print_dccpoptions_summary((uchar_t *)dccp + option_offset,
+		    (uchar_t *)dccp + dccp->dh_offset * 4);
+	}
+
+
+	if (flags & F_DTAIL) {
+		show_header("DCCP:  ", "DCCP Header", dccplen);
+		show_space();
+
+		(void) sprintf(get_line((char *)(uintptr_t)dccp->dh_sport -
+		    dlc_header, 2), "Source port = %d",
+		    ntohs(dccp->dh_sport));
+
+		(void) sprintf(get_line((char *)(uintptr_t)dccp->dh_dport -
+		    dlc_header, 2), "Destination port = %d",
+		    ntohs(dccp->dh_dport));
+
+		(void) sprintf(get_line(((char *)(uintptr_t)dccp->dh_offset -
+		    dlc_header) + 4, 1), "Data offset = %d bytes",
+		    dccp->dh_offset * 4);
+
+		(void) sprintf(get_line(((char *)(uintptr_t)dccp->dh_ccval -
+		    dlc_header) + 4, 1), "CCVal = %d",
+		    dccp->dh_ccval);
+
+		(void) sprintf(get_line(((char *)(uintptr_t)dccp->dh_cscov -
+		    dlc_header) + 4, 1), "Checksum coverage (CsCov) = %d",
+		    dccp->dh_cscov);
+
+		(void) sprintf(get_line(((char *)(uintptr_t)dccp->dh_sum -
+		    dlc_header) + 4, 1), "Checksum = 0x%04x",
+		    ntohs(dccp->dh_sum));
+
+		(void) sprintf(get_line(((char *)(uintptr_t)dccp->dh_type -
+		    dlc_header) + 4, 1), "Type = %d (%s)",
+		    dccp->dh_type, get_type(dccp->dh_type));
+
+		(void) sprintf(get_line(((char *)(uintptr_t)dccp->dh_x -
+		    dlc_header) + 4, 1), "Extended sequence numbers = %d",
+		    dccp->dh_x);
+
+		(void) sprintf(get_line(((char *)(uintptr_t)dccp->dh_seq -
+		    dlc_header) + 4, 1), "Sequence number = %d",
+		    seq);
+
+		/*
+		 * All packets except DCCP-Request and DCCP-Data carry
+		 * an acknowledgement number.
+		 */
+		if (dccp->dh_type != 0 && dccp->dh_type != 2) {
+		(void) sprintf(get_line(((char *)(uintptr_t)dccp->dh_seq -
+		    dlc_header) + 4, 1), "Acknowledgement number = %d",
+		    seq);
+		}
+
+		print_dccpoptions((uchar_t *)dccp + option_offset,
+		    (uchar_t *)dccp + dccp->dh_offset * 4);
+
+		show_space();
+	}
+
+	return (dccplen);
+}
+
+static void
+print_dccpoptions_summary(uchar_t *up, uchar_t *end)
+{
+	uchar_t		*value;
+	uint8_t		option_type;
+	uint8_t		option_length;
+	int		len;
+	boolean_t	mandatory = B_FALSE;
+
+	while (up != end) {
+		option_length = 0;
+		option_type = *up++;
+
+		/*
+		 * Is this a variable length option?
+		 */
+		if (option_type > 31) {
+			option_length = *up++;
+			option_length -= 2;
+			value = up;
+
+			up += option_length;
+		}
+		switch (option_type) {
+		case 0:		/* Padding */
+			break;
+		case 1:		/* Mandatory */
+			mandatory = B_TRUE;
+			break;
+		case 2:		/* Slow receiver */
+			break;
+		case 3 ... 31:	/* Reserved */
+			break;
+		case 32:	/* Change L */
+			break;
+		case 33:	/* Confirm L */
+			break;
+		case 34:	/* Change R */
+			break;
+		case 35:	/* Confirm R */
+			break;
+		case 36:	/* Init cookie */
+			break;
+		case 37:	/* NDP count */
+			break;
+		case 38:	/* Ack Vector 0 */
+			break;
+		case 39:	/* Ack vector 1 */
+			break;
+		case 40:	/* Data dropped */
+			break;
+		case 41:	/* Timestamp */
+			break;
+		case 42:	/* Timestamp echo */
+			break;
+		case 43:	/* Elapsed time */
+			break;
+		case 44:	/* Data checksum */
+			break;
+
+		default:
+			break;
+		}
+
+		if (option_type != 1) {
+			mandatory = B_FALSE;
+		}
+	}
+}
+
+static void
+print_dccpoptions(uchar_t *up, uchar_t *end)
+{
+	uchar_t		*value;
+	uint8_t		option_type;
+	uint8_t		option_length;
+	int		len;
+	boolean_t	mandatory = B_FALSE;
+
+	if (up == end) {
+		(void) sprintf(get_line((char *)&up - dlc_header, 1),
+		     "No options");
+		return;
+	}
+
+	(void) sprintf(get_line((char *)&up - dlc_header, 1),
+	    "Options: (%d bytes)", (int)(end - up));
+
+	while (up != end) {
+		option_length = 0;
+		option_type = *up++;
+
+		/*
+		 * Is this a variable length option?
+		 */
+		if (option_type > 31) {
+			option_length = *up++;
+			option_length -= 2;
+			value = up;
+
+			up += option_length;
+		}
+
+		switch (option_type) {
+		case 0:		/* Padding */
+			(void) sprintf(get_line(((char *)(uintptr_t)up -
+			    dlc_header) + 4, 1), "Padding");
+			break;
+		case 1:		/* Mandatory */
+			(void) sprintf(get_line(((char *)(uintptr_t)up -
+			    dlc_header) + 4, 1), "Mandatory");
+			mandatory = B_TRUE;
+			break;
+		case 2:		/* Slow receiver */
+			(void) sprintf(get_line(((char *)(uintptr_t)up -
+			    dlc_header) + 4, 1), "Slow receiver");
+			break;
+		case 3 ... 31:	/* Reserved */
+			(void) sprintf(get_line(((char *)(uintptr_t)up -
+			    dlc_header) + 4, 1), "Reserved");
+			break;
+		case 32:	/* Change L */
+			(void) sprintf(get_line(((char *)(uintptr_t)up -
+			    dlc_header) + 4, 1), "Change L");
+			break;
+		case 33:	/* Confirm L */
+			(void) sprintf(get_line(((char *)(uintptr_t)up -
+			    dlc_header) + 4, 1), "Confirm L");
+			break;
+		case 34:	/* Change R */
+			(void) sprintf(get_line(((char *)(uintptr_t)up -
+			    dlc_header) + 4, 1), "Change R");
+			break;
+		case 35:	/* Confirm R */
+			(void) sprintf(get_line(((char *)(uintptr_t)up -
+			    dlc_header) + 4, 1), "Confirm R");
+			break;
+		case 36:	/* Init cookie */
+			(void) sprintf(get_line(((char *)(uintptr_t)up -
+			    dlc_header) + 4, 1), "Init cookie");
+			break;
+		case 37:	/* NDP count */
+			(void) sprintf(get_line(((char *)(uintptr_t)up -
+			    dlc_header) + 4, 1), "NDP count");
+			break;
+		case 38:	/* Ack vector 0 */
+			(void) sprintf(get_line(((char *)(uintptr_t)up -
+			    dlc_header) + 4, 1), "Ack vector 0");
+			break;
+		case 39:	/* Ack vector 1 */
+			(void) sprintf(get_line(((char *)(uintptr_t)up -
+			    dlc_header) + 4, 1), "Ack vector 1");
+			break;
+		case 40:	/* Data dropped */
+			(void) sprintf(get_line(((char *)(uintptr_t)up -
+			    dlc_header) + 4, 1), "Data dropped");
+			break;
+		case 41:	/* Timestamp */
+			(void) sprintf(get_line(((char *)(uintptr_t)up -
+			    dlc_header) + 4, 1), "Timestamp");
+			break;
+		case 42:	/* Timestamp echo */
+			(void) sprintf(get_line(((char *)(uintptr_t)up -
+			    dlc_header) + 4, 1), "TImestamp echo");
+			break;
+		case 43:	/* Elapsed time */
+			(void) sprintf(get_line(((char *)(uintptr_t)up -
+			    dlc_header) + 4, 1), "Elapsed time");
+			break;
+		case 44:	/* Data checksum */
+			(void) sprintf(get_line(((char *)(uintptr_t)up -
+			    dlc_header) + 4, 1), "Data checksum");
+			break;
+
+		default:
+			(void) sprintf(get_line(((char *)(uintptr_t)up -
+			    dlc_header) + 4, 1), "Unknown");
+			break;
+		}
+
+		if (option_type != 1) {
+			mandatory = B_FALSE;
+		}
+	}
+}
--- old/usr/src/cmd/cmd-inet/usr.sbin/snoop/snoop_filter.c	2012-08-18 10:36:58.032703741 +0000
+++ new/usr/src/cmd/cmd-inet/usr.sbin/snoop/snoop_filter.c	2012-08-18 10:36:58.061056931 +0000
@@ -1346,6 +1346,8 @@
 	"ah",		6,  1, IPPROTO_AH,	 1,	OP_OFFSET_LINK,
 	"sctp",		9,  1, IPPROTO_SCTP,	 0,	OP_OFFSET_LINK,
 	"sctp",		6,  1, IPPROTO_SCTP,	 1,	OP_OFFSET_LINK,
+	"dccp",		9,  1, IPPROTO_DCCP,	 0,	OP_OFFSET_LINK,
+	"dccp",		6,  1, IPPROTO_DCCP,	 1,	OP_OFFSET_LINK,
 	0,		0,  0, 0,		 0,	0
 };
 
@@ -1372,6 +1374,8 @@
 	"ah",		6,  1, IPPROTO_AH,	 1,	OP_OFFSET_LINK,
 	"sctp",		9,  1, IPPROTO_SCTP,	 0,	OP_OFFSET_LINK,
 	"sctp",		6,  1, IPPROTO_SCTP,	 1,	OP_OFFSET_LINK,
+	"dccp",		9,  1, IPPROTO_DCCP,	 0,	OP_OFFSET_LINK,
+	"dccp",		6,  1, IPPROTO_DCCP,	 1,	OP_OFFSET_LINK,
 	0,		0,  0, 0,		 0,	0
 };
 
@@ -1393,6 +1397,8 @@
 	"ah",		6,  1, IPPROTO_AH,	1,	OP_OFFSET_LINK,
 	"sctp",		9,  1, IPPROTO_SCTP,	0,	OP_OFFSET_LINK,
 	"sctp",		6,  1, IPPROTO_SCTP,	1,	OP_OFFSET_LINK,
+	"dccp",		9,  1, IPPROTO_DCCP,	0,	OP_OFFSET_LINK,
+	"dccp",		6,  1, IPPROTO_DCCP,	1,	OP_OFFSET_LINK,
 	0,		0,  0, 0,		0,	0
 };
 
--- old/usr/src/cmd/cmd-inet/usr.sbin/snoop/snoop_ip.c	2012-08-18 10:36:58.430359566 +0000
+++ new/usr/src/cmd/cmd-inet/usr.sbin/snoop/snoop_ip.c	2012-08-18 10:36:58.447322753 +0000
@@ -299,6 +299,10 @@
 				(void) interpret_sctp(flags,
 				    (struct sctp_hdr *)data, iplen, fraglen);
 				break;
+			case IPPROTO_DCCP:
+				(void) interpret_dccp(flags,
+				    (struct dccphdr *)data, iplen, fraglen);
+				break;
 			}
 		}
 	}
@@ -477,6 +481,10 @@
 		case IPPROTO_OSPF:
 			interpret_ospf6(flags, data, iplen, fraglen);
 			break;
+		case IPPROTO_DCCP:
+			(void) interpret_dccp(flags, (struct dccphdr *)data,
+			    iplen, fraglen);
+			break;
 		}
 	}
 
@@ -730,6 +738,7 @@
 	case IPPROTO_EON:	return ("EON");
 	case IPPROTO_RAW:	return ("RAW");
 	case IPPROTO_OSPF:	return ("OSPF");
+	case IPPROTO_DCCP:	return ("DCCP");
 	default:		return ("");
 	}
 }
--- old/usr/src/cmd/cmd-inet/usr.sbin/snoop/snoop_ipsec.c	2012-08-18 10:36:58.903832254 +0000
+++ new/usr/src/cmd/cmd-inet/usr.sbin/snoop/snoop_ipsec.c	2012-08-18 10:36:58.913464934 +0000
@@ -236,6 +236,10 @@
 				(void) interpret_udp(flags,
 				    (struct udphdr *)data, new_iplen, fraglen);
 				break;
+			case IPPROTO_DCCP:
+				(void) interpret_dccp(flags,
+				    (struct dccphdr *)data, new_iplen, fraglen);
+				break;
 			/* default case is to not print anything else */
 		}
 
--- old/usr/src/cmd/cmd-inet/usr.sbin/snoop/snoop_pf.c	2012-08-18 10:36:59.362113918 +0000
+++ new/usr/src/cmd/cmd-inet/usr.sbin/snoop/snoop_pf.c	2012-08-18 10:36:59.414585345 +0000
@@ -153,6 +153,8 @@
 	{IPPROTO_ESP, ETHERTYPE_IPV6, IPV6_TYPE_HEADER_OFFSET},
 	{IPPROTO_AH, ETHERTYPE_IP,   IPV4_TYPE_HEADER_OFFSET},
 	{IPPROTO_AH, ETHERTYPE_IPV6, IPV6_TYPE_HEADER_OFFSET},
+	{IPPROTO_DCCP, ETHERTYPE_IP,   IPV4_TYPE_HEADER_OFFSET},
+	{IPPROTO_DCCP, ETHERTYPE_IPV6, IPV6_TYPE_HEADER_OFFSET},
 	{-1, 0, 0}	/* must be the final entry */
 };
 
@@ -187,6 +189,10 @@
 	    IPV4_TYPE_HEADER_OFFSET},
 	{IPPROTO_AH, (DL_IPNETINFO_VERSION << 8 | AF_INET6),
 	    IPV6_TYPE_HEADER_OFFSET},
+	{IPPROTO_DCCP, (DL_IPNETINFO_VERSION << 8 | AF_INET),
+	    IPV4_TYPE_HEADER_OFFSET},
+	{IPPROTO_DCCP, (DL_IPNETINFO_VERSION << 8 | AF_INET6),
+	    IPV6_TYPE_HEADER_OFFSET},
 	{-1, 0, 0}	/* must be the final entry */
 };
 
@@ -206,6 +212,8 @@
 	{IPPROTO_ESP, ETHERTYPE_IPV6, IPV6_TYPE_HEADER_OFFSET},
 	{IPPROTO_AH, ETHERTYPE_IP,   IPV4_TYPE_HEADER_OFFSET},
 	{IPPROTO_AH, ETHERTYPE_IPV6, IPV6_TYPE_HEADER_OFFSET},
+	{IPPROTO_DCCP, ETHERTYPE_IP,   IPV4_TYPE_HEADER_OFFSET},
+	{IPPROTO_DCCP, ETHERTYPE_IPV6, IPV6_TYPE_HEADER_OFFSET},
 	{-1, 0, 0}	/* must be the final entry */
 };
 
@@ -1328,6 +1336,13 @@
 			break;
 		}
 
+		if (EQ("dccp")) {
+			pf_check_transport_protocol(IPPROTO_DCCP);
+			opstack++;
+			next();
+			break;
+		}
+
 		if (EQ("(")) {
 			inBrace++;
 			next();
--- old/usr/src/cmd/cmd-inet/usr.sbin/snoop/snoop_rport.c	2012-08-18 10:36:59.832713471 +0000
+++ new/usr/src/cmd/cmd-inet/usr.sbin/snoop/snoop_rport.c	2012-08-18 10:36:59.880379340 +0000
@@ -143,7 +143,8 @@
 	const struct porttable *p, *pt;
 
 	switch (proto) {
-	case IPPROTO_SCTP: /* fallthru */
+	case IPPROTO_DCCP: /* fallthru */
+	case IPPROTO_SCTP:
 	case IPPROTO_TCP: pt = pt_tcp; break;
 	case IPPROTO_UDP: pt = pt_udp; break;
 	default: return (NULL);
--- old/usr/src/cmd/devfsadm/misc_link.c	2012-08-18 10:37:00.253415552 +0000
+++ new/usr/src/cmd/devfsadm/misc_link.c	2012-08-18 10:37:00.319880705 +0000
@@ -101,8 +101,8 @@
 	    TYPE_EXACT | DRV_RE, ILEVEL_1, minor_name
 	},
 	{ "pseudo", "ddi_pseudo",
-	    "(^ip$)|(^tcp$)|(^udp$)|(^icmp$)|"
-	    "(^ip6$)|(^tcp6$)|(^udp6$)|(^icmp6$)|"
+	    "(^ip$)|(^tcp$)|(^udp$)|(^icmp$)|(^dccp$)|"
+	    "(^ip6$)|(^tcp6$)|(^udp6$)|(^icmp6$)|(^dccp6$)|"
 	    "(^rts$)|(^arp$)|(^ipsecah$)|(^ipsecesp$)|(^keysock$)|(^spdsock$)|"
 	    "(^nca$)|(^rds$)|(^sdp$)|(^ipnet$)|(^dlpistub$)|(^bpf$)",
 	    TYPE_EXACT | DRV_RE, ILEVEL_1, minor_name
--- old/usr/src/cmd/mdb/common/modules/genunix/genunix.c	2012-08-18 10:37:00.824583716 +0000
+++ new/usr/src/cmd/mdb/common/modules/genunix/genunix.c	2012-08-18 10:37:00.880491909 +0000
@@ -4081,7 +4081,7 @@
 		dladm, dladm_help },
 	{ "mi", ":[-p] [-d | -m]", "filter and display MI object or payload",
 		mi },
-	{ "netstat", "[-arv] [-f inet | inet6 | unix] [-P tcp | udp | icmp]",
+	{ "netstat", "[-arv] [-f inet | inet6 | unix] [-P tcp | udp | icmp | dccp]",
 		"show network statistics", netstat },
 	{ "sonode", "?[-f inet | inet6 | unix | #] "
 		"[-t stream | dgram | raw | #] [-p #]",
@@ -4480,6 +4480,8 @@
 		tcp_stacks_walk_init, tcp_stacks_walk_step, NULL },
 	{ "udp_stacks", "walk all the udp_stack_t",
 		udp_stacks_walk_init, udp_stacks_walk_step, NULL },
+	{ "dccp_stacks", "walk all the dccp_stack_t",
+		dccp_stacks_walk_init, dccp_stacks_walk_step, NULL },
 
 	/* from netstack.c */
 	{ "netstack", "walk a list of kernel netstacks",
--- old/usr/src/cmd/mdb/common/modules/genunix/net.c	2012-08-18 10:37:01.414967894 +0000
+++ new/usr/src/cmd/mdb/common/modules/genunix/net.c	2012-08-18 10:37:01.446987674 +0000
@@ -47,6 +47,7 @@
 #include <inet/udp_impl.h>
 #include <inet/rawip_impl.h>
 #include <inet/mi.h>
+#include <inet/dccp_impl.h>
 #include <fs/sockfs/socktpi_impl.h>
 #include <net/bridge_impl.h>
 #include <io/trill_impl.h>
@@ -142,6 +143,30 @@
 	return (wsp->walk_callback(kaddr, wsp->walk_layer, wsp->walk_cbdata));
 }
 
+int
+dccp_stacks_walk_init(mdb_walk_state_t *wsp)
+{
+	if (mdb_layered_walk("netstack", wsp) == -1) {
+		mdb_warn("can't walk 'netstack'");
+		return (WALK_ERR);
+	}
+	return (WALK_NEXT);
+}
+
+int
+dccp_stacks_walk_step(mdb_walk_state_t *wsp)
+{
+	uintptr_t kaddr;
+	netstack_t nss;
+
+	if (mdb_vread(&nss, sizeof (nss), wsp->walk_addr) == -1) {
+		mdb_warn("can't read netstack at %p", wsp->walk_addr);
+		return (WALK_ERR);
+	}
+	kaddr = (uintptr_t)nss.netstack_modules[NS_DCCP];
+	return (wsp->walk_callback(kaddr, wsp->walk_layer, wsp->walk_cbdata));
+}
+
 /*
  * Print an IPv4 address and port number in a compact and easy to read format
  * The arguments are in network byte order
@@ -207,6 +232,27 @@
 	return (udp->udp_connp->conn_ipversion == IPV6_VERSION);
 }
 
+static int
+net_dccp_active(const dccp_t *dccp)
+{
+	return ((dccp->dccp_state == TS_IDLE) ||
+	    (dccp->dccp_state == TS_DATA_XFER));
+}
+
+static int
+net_dccp_ipv4(const dccp_t *dccp)
+{
+	return ((dccp->dccp_connp->conn_ipversion == IPV4_VERSION) ||
+	    (IN6_IS_ADDR_UNSPECIFIED(&dccp->dccp_connp->conn_laddr_v6) &&
+	    (dccp->dccp_state <= DCCPS_LISTEN)));
+}
+
+static int
+net_dccp_ipv6(const dccp_t *dccp)
+{
+	return (dccp->dccp_connp->conn_ipversion == IPV6_VERSION);
+}
+
 int
 sonode_walk_init(mdb_walk_state_t *wsp)
 {
@@ -745,6 +791,66 @@
 	return (WALK_NEXT);
 }
 
+static void
+netstat_dccp_verbose_pr(const dccp_t *dccp)
+{
+/* XXX:DCCP
+	mdb_printf("       %5i %08x %08x %5i %08x %08x %5li %5i\n",
+	    tcp->tcp_swnd, tcp->tcp_snxt, tcp->tcp_suna, tcp->tcp_rwnd,
+	    tcp->tcp_rack, tcp->tcp_rnxt, tcp->tcp_rto, tcp->tcp_mss);
+*/
+}
+
+/*ARGSUSED*/
+static int
+netstat_dccp_cb(uintptr_t kaddr, const void *walk_data, void *cb_data)
+{
+	netstat_cb_data_t *ncb = cb_data;
+	uint_t opts = ncb->opts;
+	int af = ncb->af;
+	uintptr_t dccp_kaddr;
+	conn_t *connp = &ncb->conn;
+	dccp_t dccps, *dccp;
+
+	if (mdb_vread(connp, sizeof (conn_t), kaddr) == -1) {
+		mdb_warn("failed to read conn_t at %p", kaddr);
+		return (WALK_ERR);
+	}
+
+	dccp_kaddr = (uintptr_t)connp->conn_dccp;
+	if (mdb_vread(&dccps, sizeof (dccp_t), dccp_kaddr) == -1) {
+		mdb_warn("failed to read tcp_t at %p", dccp_kaddr);
+		return (WALK_ERR);
+	}
+
+	dccp = &dccps;
+	connp->conn_dccp = dccp;
+	dccp->dccp_connp = connp;
+
+	if (!((opts & NETSTAT_ALL) || net_dccp_active(dccp)) ||
+	    (af == AF_INET && !net_dccp_ipv4(dccp)) ||
+	    (af == AF_INET6 && !net_dccp_ipv6(dccp))) {
+		return (WALK_NEXT);
+	}
+
+	mdb_printf("%0?p %2i ", dccp_kaddr, dccp->dccp_state);
+	if (af == AF_INET) {
+		net_ipv4addrport_pr(&connp->conn_laddr_v6, connp->conn_lport);
+		mdb_printf(" ");
+		net_ipv4addrport_pr(&connp->conn_faddr_v6, connp->conn_fport);
+	} else if (af == AF_INET6) {
+		net_ipv6addrport_pr(&connp->conn_laddr_v6, connp->conn_lport);
+		mdb_printf(" ");
+		net_ipv6addrport_pr(&connp->conn_faddr_v6, connp->conn_fport);
+	}
+	mdb_printf(" %5i", ns_to_stackid((uintptr_t)connp->conn_netstack));
+	mdb_printf(" %4i\n", connp->conn_zoneid);
+	if (opts & NETSTAT_VERBOSE)
+		netstat_dccp_verbose_pr(dccp);
+
+	return (WALK_NEXT);
+}
+
 /*
  * print the address of a unix domain socket
  *
@@ -1216,6 +1322,13 @@
 		if (status != DCMD_OK)
 			goto out;
 	}
+
+	if ((optP == NULL) || (strcmp("dccp", optP) == 0)) {
+		status = netstat_print_common("dccp_conn_cache", IPPROTO_DCCP,
+		    netstat_dccp_cb, cbdata);
+		if (status != DCMD_OK)
+			goto out;
+	}
 out:
 	mdb_free(cbdata, sizeof (netstat_cb_data_t));
 	return (status);
--- old/usr/src/cmd/mdb/common/modules/genunix/net.h	2012-08-18 10:37:01.844473962 +0000
+++ new/usr/src/cmd/mdb/common/modules/genunix/net.h	2012-08-18 10:37:01.862477111 +0000
@@ -47,6 +47,8 @@
 extern int tcp_stacks_walk_step(mdb_walk_state_t *);
 extern int udp_stacks_walk_init(mdb_walk_state_t *);
 extern int udp_stacks_walk_step(mdb_walk_state_t *);
+extern int dccp_stacks_walk_init(mdb_walk_state_t *);
+extern int dccp_stacks_walk_step(mdb_walk_state_t *);
 
 extern int sonode(uintptr_t, uint_t, int, const mdb_arg_t *);
 extern int mi(uintptr_t, uint_t, int, const mdb_arg_t *);
